package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.segmentation.OcrSpecialRuleTest;
import com.docus.server.infrastructure.dao.IOcrSpecialRuleTestDao;
import com.docus.server.infrastructure.mapper.OcrSpecialRuleTestMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * 特殊策略表-调试 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-08-29
 */
@Repository
public class OcrSpecialRuleTestDaoImpl extends BaseDaoImpl<OcrSpecialRuleTestMapper, OcrSpecialRuleTest> implements IOcrSpecialRuleTestDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public OcrSpecialRuleTest findById(Long id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param ocrSpecialRuleTest 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(OcrSpecialRuleTest ocrSpecialRuleTest) {
        return super.save(ocrSpecialRuleTest);
    }

    /**
     * 编辑
     *
     * @param ocrSpecialRuleTest 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(OcrSpecialRuleTest ocrSpecialRuleTest) {
        return super.updateById(ocrSpecialRuleTest);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<OcrSpecialRuleTest> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<OcrSpecialRuleTest> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchDTO.getBeginTime() != null) {
            query.ge(OcrSpecialRuleTest::getCreateTime, searchDTO.getBeginTime());
        }
        if (searchDTO.getEndTime() != null) {
            Date endTime = searchDTO.getEndTime();
            query.le(OcrSpecialRuleTest::getCreateTime, endTime);
        }
        //关键字比较，多个列or
        //if (!StringUtils.isEmpty(searchDTO.getKeyword())) {
        //单个列用like
        //query. like(OcrSpecialRuleTest::getxxx, searchDTO.getKeyword());
        //多个列用like
        //query. and(sub -> sub.like(OcrSpecialRuleTest::getxx1, searchDTO.getKeyword())
        // оr(). like(OcrSpecialRuleTest::getXX2, searchDTO.getKeyword()))
        //);
        //}
        //默认createTime倒序排序
        query.orderByDesc(OcrSpecialRuleTest::getCreateTime);
        List<OcrSpecialRuleTest> list = super.find(query);
        return new PageResult<>(list);
    }

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    @Override
    public int findByIdAndName(Long id, String name) {
        LambdaQueryWrapper<OcrSpecialRuleTest> query = Wrappers.lambdaQuery();
        if (id != null) {
            query.ne(OcrSpecialRuleTest::getId, id);
        }
        //if (Func.isNotBlank(name)) {
        //   query.eq(OcrSpecialRuleTest::getName, name);
        //}

        return baseMapper.selectCount(query);
    }
}
